% This code if for the book titled: Advanced Digital Signal Processing 
% of Seismic Data by Wail A. Mousa 
% January 1, 2020.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Chapter 7 MATLAB codes %%%
%%% Figure 7.1 Example 7.1%%
clear,clc,close all
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%a
% The sesimic wavelet
n=-5:32;
w=zeros(size(n));
w(n==0)=1;
w(n==1)=-0.5;
figure, stem(n,w,'k','fill','LineWidth',2)
xlabel('\itn','FontName','Times','FontSize',14)
ylabel('{\itw}[{\itn}]','FontName','Times','FontSize',14)
axis tight
set(gcf,'PaperPositionMode','auto')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%b
%Its inverse filter
f=0.5.^n;
f=f.*(n>=0);
figure, stem(n,f,'k','fill','LineWidth',2)
xlabel('\itn','FontName','Times','FontSize',14)
ylabel('{\itf}[{\itn}]','FontName','Times','FontSize',14)
axis tight
set(gcf,'PaperPositionMode','auto')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% The convolution of the wavelet and its inverse filter (=delta[n])
y=conv(f,w);
y=y(6:length(f)+5);
figure, stem(n,y,'k','fill','LineWidth',2)
xlabel('\itn','FontName','Times','FontSize',14)
ylabel('{\itw}[{\itn}]*{\itf}[{\itn}]','FontName','Times','FontSize',14)
axis tight
set(gcf,'PaperPositionMode','auto')
