% This code if for the book titled: Advanced Digital Signal Processing 
% of Seismic Data by Wail A. Mousa 
% January 1, 2020.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Chapter 7 MATLAB codes %%%
%%% Figure 7.2 Example 7.2%%
clear,clc,close all
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%a
n=-5:32;
w=zeros(size(n));
w(n==0)=1;
w(n==1)=-0.5;
%The inverse filter
f=0.5.^n;
f=f.*(n>=0);
y=conv(f,w);
y=y(6:length(f)+5);
figure, stem(n,y,'k','fill','LineWidth',2)
xlabel('\itn','FontName','Times','FontSize',14)
ylabel('{\itw}[{\itn}]*{\itf}[{\itn}]={\it\delta}[{\itn}]','FontName','Times','FontSize',14)
axis([-5,32,-0.5,1.1])
set(gcf,'PaperPositionMode','auto')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%b
wf2=zeros(size(n));
wf2(n==0)=1;
wf2(n==2)=-0.25;
figure, stem(n,wf2,'k','fill','LineWidth',2)
xlabel('\itn','FontName','Times','FontSize',14)
ylabel('{\itw}[{\itn}]*{\itf_{2}}[{\itn}]','FontName','Times','FontSize',14)
axis([-5,32,-.5,1.1])
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%c
wf3=zeros(size(n));
wf3(n==0)=1;
wf3(n==3)=-1/8;
figure, stem(n,wf3,'k','fill','LineWidth',2)
xlabel('\itn','FontName','Times','FontSize',14)
ylabel('{\itw}[{\itn}]*{\itf_{3}}[{\itn}]','FontName','Times','FontSize',14)
axis([-5,32,-.5,1.1])
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%d
wf4=zeros(size(n));
wf4(n==0)=1;
wf4(n==4)=-1/16;
figure, stem(n,wf4,'k','fill','LineWidth',2)
xlabel('\itn','FontName','Times','FontSize',14)
ylabel('{\itw}[{\itn}]*{\itf_{4}}[{\itn}]','FontName','Times','FontSize',14)
axis([-5,32,-.5,1.1])

