% This code if for the book titled: Advanced Digital Signal Processing 
% of Seismic Data by Wail A. Mousa 
% January 1, 2020.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Chapter 7 MATLAB codes %%%
%%% Figure 7.7 Example 7.3%%
clear,clc,close all
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%a
% A seismic sequence with an echo (a multiple)
nn=[0:20-1];
Data=zeros(1,20)';
Data(nn==0)=8.5;
Data(nn==1)=4.5;
Data(nn==3)=4.5;
Data(nn==4)=2.25;
figure,stem(nn,Data,'fill','k','LineWidth',2);
xlabel('\itn','FontName','Times','FontSize',14)
ylabel('{\itg}[{\itn}]','FontName','Times','FontSize',14)
set(gcf,'PaperPositionMode','auto')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%b
%The optimal FIR filter with N=3
hopt=zeros(1,20);
hopt(nn==0)=.444;
hopt(nn==1)=0.047;
hopt(nn==2)=-0.164;
figure,stem(nn,hopt,'fill','k','LineWidth',2);
xlabel('\itn','FontName','Times','FontSize',14)
ylabel('{\ith{opt}}[{\itn}]','FontName','Times','FontSize',14)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%c
%The filtered signal 
y=conv(Data,hopt);
y=y(2:length(nn)+1);
figure,stem(nn,y,'fill','k','LineWidth',2);
xlabel('\itn','FontName','Times','FontSize',14)
ylabel('{\ity}[{\itn}]','FontName','Times','FontSize',14)
set(gcf,'PaperPositionMode','auto')



